ViennaCL - The Vienna Computing Library: viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward > Class Template Reference

ViennaCL - The Vienna Computing Library 1.7.1 Free open-source GPU-accelerated linear algebra and solver library. |

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Types | Public Member Functions | List of all members
viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward > Class Template Reference

A const iterator for sparse matrices of type std::vector<std::map<SizeT, NumericT> > More...

`#include <adapter.hpp>`

## Public Types
typedef self_type | iterator1
typedef self_type | iterator2
typedef vcl_size_t | size_type

## Public Member Functions
| const_sparse_matrix_adapted_iterator (std::vector< std::map< SizeT, NumericT > > const &mat, int i, int j)
NumericT | operator* (void) const
self_type & | operator++ (void)
self_type | operator++ (int)
self_type | operator+= (SizeT offset)
bool | operator== (self_type const &other) const
bool | operator!= (self_type const &other) const
size_type | index1 () const
size_type | index2 () const
const_sparse_matrix_adapted_iterator < NumericT, SizeT,!is_iterator1, true > | begin () const
const_sparse_matrix_adapted_iterator < NumericT, SizeT,!is_iterator1, true > | end () const

## Detailed Description

### template<typename NumericT, typename SizeT, bool is_iterator1, bool is_forward>
class viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward >

A const iterator for sparse matrices of type std::vector<std::map<SizeT, NumericT> >

The iterator behaves like ublas iterators. Attention: Iteration along first columns and then rows via .begin() is untested!

Template Parameters

  NumericT | either float or double
  is_iterator1 | if true, this iterator iterates along increasing row indices, otherwise along increasing column indices
  increment | if +1, this is a forward iterator, if -1 we have a reverse iterator

Definition at line 48 of file adapter.hpp.

## Member Typedef Documentation

template<typename NumericT, typename SizeT, bool is_iterator1, bool is_forward>

typedef self_type viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward >::iterator1

Definition at line 53 of file adapter.hpp.

template<typename NumericT, typename SizeT, bool is_iterator1, bool is_forward>

typedef self_type viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward >::iterator2

Definition at line 54 of file adapter.hpp.

template<typename NumericT, typename SizeT, bool is_iterator1, bool is_forward>

typedef vcl_size_t viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward >::size_type

Definition at line 55 of file adapter.hpp.

## Constructor & Destructor Documentation

template<typename NumericT, typename SizeT, bool is_iterator1, bool is_forward>

viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward >::const_sparse_matrix_adapted_iterator | ( | std::vector< std::map< SizeT, NumericT > > const & | mat,
|  | int | i,
|  | int | j
| ) |  |
| inline

Definition at line 57 of file adapter.hpp.

## Member Function Documentation

template<typename NumericT, typename SizeT, bool is_iterator1, bool is_forward>

const_sparse_matrix_adapted_iterator<NumericT, SizeT, !is_iterator1, true> viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward >::begin | ( |  | ) | const
| inline

Definition at line 159 of file adapter.hpp.

template<typename NumericT, typename SizeT, bool is_iterator1, bool is_forward>

const_sparse_matrix_adapted_iterator<NumericT, SizeT, !is_iterator1, true> viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward >::end | ( |  | ) | const
| inline

Definition at line 163 of file adapter.hpp.

template<typename NumericT, typename SizeT, bool is_iterator1, bool is_forward>

size_type viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward >::index1 | ( |  | ) | const
| inline

Definition at line 149 of file adapter.hpp.

template<typename NumericT, typename SizeT, bool is_iterator1, bool is_forward>

size_type viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward >::index2 | ( |  | ) | const
| inline

Definition at line 150 of file adapter.hpp.

template<typename NumericT, typename SizeT, bool is_iterator1, bool is_forward>

bool viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward >::operator!= | ( | self_type const & | other | ) | const
| inline

Definition at line 147 of file adapter.hpp.

template<typename NumericT, typename SizeT, bool is_iterator1, bool is_forward>

NumericT viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward >::operator* | ( | void |  | ) | const
| inline

Definition at line 88 of file adapter.hpp.

template<typename NumericT, typename SizeT, bool is_iterator1, bool is_forward>

self_type& viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward >::operator++ | ( | void |  | ) |
| inline

Definition at line 105 of file adapter.hpp.

template<typename NumericT, typename SizeT, bool is_iterator1, bool is_forward>

self_type viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward >::operator++ | ( | int |  | ) |
| inline

Definition at line 120 of file adapter.hpp.

template<typename NumericT, typename SizeT, bool is_iterator1, bool is_forward>

self_type viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward >::operator+= | ( | SizeT | offset | ) |
| inline

Definition at line 122 of file adapter.hpp.

template<typename NumericT, typename SizeT, bool is_iterator1, bool is_forward>

bool viennacl::tools::const_sparse_matrix_adapted_iterator< NumericT, SizeT, is_iterator1, is_forward >::operator== | ( | self_type const & | other | ) | const
| inline

Definition at line 141 of file adapter.hpp.

The documentation for this class was generated from the following file:

- viennacl/tools/adapter.hpp